#!/usr/bin/perl

# 3Dgrapher.pl Version 1.0
# 
# Written by Jeff Carr <jcarr@linuxppc.org> July 1998 under GNU GPL
# Some things are not implemented yet and other things could maybe be optimized
# I had some simple examples at http://www.linuxppc.org/~jcarr/gimp/
# TODO: Draw Axis, Allow different palette, Allow camara tilt and eye movement
# subroutine z is where the function z(x,y) is. Lower $points/$frames to
# render test images and animations faster. 
# NOTES: gimp animation support is a great way to visualize 4D surfaces!


$points = 10;                  #The number of lines on a side
$frames = 60;                  #The number of frames in the animation
@camara = ( 4 , 1 , 1 );       #This is where you are
@focal = ( 0 , 0 , 0 );	       #This is where look are looking
$theta = 3.1415 / 7;           #This is how your head is tilted

$startx =     -2; $starty =     -2;
$endx   =     2; $endy   =     2;

$width = 250; 			# Image Width
$height = 250;			# Image height
$scale  = 150;
$offsetx = 100;
$offsety = 100;

sub z
{
	# This is the function z(x,y)
	return sin( (@_[0] * @_[0] + @_[1] * @_[1])/2 + $giantAngle );
}

$rangex = $endx - $startx;
$rangey = $endy - $starty;
$stepx = ( $endx - $startx ) / $points;
$stepy = ( $endy - $starty ) / $points;

print "x= $startx -> $endx\n";
print "y= $starty -> $endy\n";
print "stepx,stepy = $stepx,$stepy\n";
print "scale = $scale\n";

use POSIX;
use Gimp qw( :auto );

sub net{
$img=new Gimp::Image($width,$height,RGB);
  
for( $giantloop = 0; $giantloop < $frames ; ++$giantloop )
{
	$bg=$img->layer_new($width,$height,RGBA_IMAGE,"Layer $giantloop",100,0);
	$img->add_layer($bg,-1);
	gimp_free_select( $img, [ 0,0 , 0,$height , $width,$height , $width,0 ] , 2 , 1 , 1 , 1);
	Palette::set_background([255,255,255]);
	$img->edit_fill ($bg);
	Display::displays_flush ();
	$giantAngle = 3.1415 * 2 * $giantloop / $frames + .1;
	@camara[0] = sin( $giantAngle );
	@camara[1] = cos( $giantAngle );
#	$blahLayer = gimp_layer_copy( $bg, TRUE );
#	gimp_image_add_layer( $img , $blahLayer, -1 );
	if( $giantloop eq 0 ) { new Gimp::Display($img); }
  
$brush = "Circle (01)";
gimp_brushes_set_brush( $brush );
	
print "Starting frame $giantloop of $frames frames\n";
print "Camara at x,y,z @camara[0],@camara[1],@camara[2]\n";

$startxNew = $startx; $endxNew = $endx; $stepxNew = $stepx;
$startyNew = $starty; $endyNew = $endy; $stepyNew = $stepy;
if( @camara[1] < 0 ) 
{
	$startxNew = $endx;
	$endxNew = $startx;
	$stepxNew *= -1;
	print "finished flipping X\n";
}

if( @camara[0] < 0 ) 
{
	$startyNew = $endy;
	$endyNew = $starty;
	$stepyNew *= -1;
	print "finished flipping Y\n";
}

#orig: for( $x = $startx; $x <= 1 ; $x += $stepx)
undef( @lastline );
$y = $startyNew;
for( $i = 0; $i <= $points ; ++$i)
{
	$x = $startxNew + $stepxNew * $i;
	push @lastline, mapPoint(changeView( $x,$y,z( $x , $y) ));
}
# print "lastline started as @lastline\n";

# for( $y = $starty; $y <= 1 ; $y += $stepy)

for( $j = 0; $j <= $points ; ++$j)
{
	$y = $startyNew + $stepyNew * $j;
	if( @camara[0] < 0 ) {
		$yColor = ( abs($endy - $y ) - $stepy) /$rangey;
		if( $yColor < 0 ) { $yColor = 0 };
	} else {
		$yColor = abs($endy - $y) /$rangey;
	}
#	print "y,endy,yColor = $y , \t $endy \t  $yColor\n";
#	if( $y == $starty ) { next; }
	$count = 0;
#orig 	for( $x = $startx; $x <= 1 ; $x += $stepx)
	for( $i = 0; $i <= $points ; ++$i)
	{
		$x = $startxNew + $stepxNew * $i;
		($newx,$newy) = mapPoint(changeView( $x,$y,z( $x , $y) ));
 $img->pencil( $bg, [@lastline[$count],@lastline[$count+1],$newx,$newy]);
		if( $count > 0 )
		{
			push @square ,(@lastline[$count],@lastline[$count+1],$newx,$newy);
			push @square , $lastx;
			push @square , $lasty;
			push @square , @lastline[$count - 2];
			push @square , @lastline[$count - 1];
#			print "square = @square\n";
			if( @camara[1] < 0 ) {
				$xColor = ( abs($endx - $x ) - $stepx) /$rangex;
				if( $xColor < 0 ) { $xColor = 0 };
			} else {
				$xColor = abs($endx - $x) /$rangex;
			}
gimp_palette_set_foreground([50+200*$xColor ,250-200*$yColor,50] );
			gimp_free_select( $img, [ @square ] , 2 , 1 , 1 , 1);
			gimp_bucket_fill( $img, $bg, 0 , 0, 100 , 50, 0, -10, -10 );
			undef( @square );
		}
#		print "@lastline[$count],@lastline[++$count],$newx,$newy\n";
		$count +=2;
		push @line, ($newx,$newy);
		$lastx = $newx;
		$lasty = $newy;
#		push @z, z($x, $y);
#		Display::displays_flush ();
	}
	$img->pencil ( $bg, [@line]);
	Display::displays_flush ();
	undef( @lastline );
	@lastline = @line;
	undef( @line );
}
	undef( @lastline,@square,$count,$newx,$newy,$x,$y );

gimp_free_select( $img, [ 0,0 , 0,$height , $width,$height , $width,0 ] , 2 , 1 , 1 , 1);
   Display::displays_flush ();
}
#  Gimp::Net::server_quit;  # kill the gimp-perl-server-extension (ugly name)

}
exit gimp_main;


sub rotate 
{
	my( $r,$t );
	( $r , $t ) = euclidTOpolar( @_[0], @_[2], );
	$t -= $theta;
	( $r, $t ) = polarTOeuclid( $r, $t ) ;
	return $r , @_[2], $t;
}

sub changeView
{
	my( $r,$t,$o,$x,$y,$z );
# 	print "x,y,z = @_[0]  \t@_[1]\t@_[2]\n";
	$sinX = sin( 3.141596 / 2 - atan2 ( @camara[0] , @camara[1] ) - atan2 ( @_[0] , @_[1] ) );
	$cosY = cos( 3.141596 / 2 - atan2 ( @camara[0] , @camara[1] ) - atan2 ( @_[0] , @_[1] ) );
#	print "at @_[0],@_[1]  \t sin = $angle3    xy angle $angle2\n";
	$x = $sinX * sqrt( @_[0] * @_[0] + @_[1] * @_[1] );
	$y = $cosY * sqrt( @_[0] * @_[0] + @_[1] * @_[1] );
#	print "x,angle = $x    \t $angle1\n";

#	$angle 
# 	print "x,z $x,@_[2] ";
	return $x , @_[2];
}

sub euclidTOpolar
{
	my ( $blah, $r, $theta );
	$r = sqrt (@_[0] * @_[0] + @_[1] * @_[1] );
	$theta = atan2  @_[0] , @_[1];
	print "theta: $theta r = $r\n";
	return sqrt (@_[0] * @_[0] + @_[1] * @_[1] ), atan2 ( @_[1] , @_[0] );
}

sub polarTOeuclid
{
#	my ( $x , $y );
#	print "r,theta = @_[0],@_[1]   ";
#	$x = $_[0] * sin( @_[1] );
#	$y = $_[0] * cos( @_[1] );
	return $_[0] * cos( @_[1] ) , $_[0] * sin( @_[1] );
}

sub mapPoint
{
	# This function maps a point x,y to the gimp image coordinates
	return $offsetx - $scale * $_[0] / $rangex , $offsety - $scale * $_[1] / $rangey;
}
