; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
; Copyright (C) 1999 Jens Reimann marvi06@ibm.net
;
; Version 0.1 - started writing the script from step-to-step instructions

(define (script-fu-explode aimg adraw bg-color expflag)
  (let* ((img (car (gimp-drawable-image adraw)))
	 (old-bg (car (gimp-palette-get-background)))
	 )
;Add this for debugging    (verbose 4)
;    (gimp-image-disable-undo img)

    (gimp-palette-set-background bg-color)

    (plug-in-edge TRUE aimg adraw 1 1 )
    (plug-in-polar-coords TRUE aimg adraw 100 0 FALSE TRUE FALSE)
    (plug-in-layer-rot90 TRUE aimg adraw)
    
    (if (= expflag TRUE )
	(plug-in-wind TRUE aimg adraw 10 1 10 0 1)
	)
    (if (= expflag FALSE )
	(plug-in-wind TRUE aimg adraw 10 0 10 0 1)
    )

    (plug-in-layer-rot270 TRUE aimg adraw)
    (plug-in-polar-coords TRUE aimg adraw 100 0 FALSE TRUE TRUE)

    (gimp-palette-set-background old-bg)

;    (gimp-image-enable-undo img)
    (gimp-displays-flush)
    )
)


(script-fu-register "script-fu-explode"
		    "<Image>/Script-Fu/Modify/Explode"
		    "Add a border around an image"
		    "Jens Reimann <marvi06@ibm.net>"
		    "Jens Reimann"
		    "03/26/99"
		    "RGB*, GRAY*"
		    SF-IMAGE "Input Image" 0
		    SF-DRAWABLE "Input Drawable" 0
		    SF-COLOR "Background Color" '(0 0 0)
		    SF-TOGGLE "Explode (false=Implode)" TRUE)
