#!/bin/sh
# This is a shell archive (produced by GNU sharutils 4.1).
# To extract the files from this archive, save it to some FILE, remove
# everything before the `!/bin/sh' line above, then type `sh FILE'.
#
# Made on 1998-07-20 07:09 EET DST by <cyborg@datazone>.
# Source directory was `/home/cyborg/work/hsiraw-0.1'.
#
# Existing files will *not* be overwritten unless `-c' is specified.
#
# This shar contains:
# length mode       name
# ------ ---------- ------------------------------------------
#    770 -rw-r--r-- Makefile
#   2419 -rw-r--r-- README
#   5220 -rw-r--r-- raw.c
#    810 -rw-r--r-- raw.h
#   5671 -rw-r--r-- rawread.c
#   7487 -rw-r--r-- rawspecs.txt
#   4015 -rw-r--r-- rawwrite.c
#    345 -rwxr-xr-x rmfolds
#
touch -am 1231235999 $$.touch >/dev/null 2>&1
if test ! -f 1231235999 && test -f $$.touch; then
  shar_touch=touch
else
  shar_touch=:
  echo
  echo 'WARNING: not restoring timestamps.  Consider getting and'
  echo "installing GNU \`touch', distributed in GNU File Utilities..."
  echo
fi
rm -f 1231235999 $$.touch
#
# ============= Makefile ==============
if test -f 'Makefile' && test X"$1" != X"-c"; then
  echo 'x - skipping Makefile (file already exists)'
else
  echo 'x - extracting Makefile (text)'
  sed 's/^X//' << 'SHAR_EOF' > 'Makefile' &&
X
#  Makefile - Copyright 1998 Tuukka Toivonen <tuukkat@ee.oulu.fi>
#
X
INCS = $(shell gimptool --cflags)
LIBS = $(shell gimptool --libs)
OPTS = -Wall -malign-loops=0 -malign-jumps=0 -malign-functions=0 -fomit-frame-pointer -O2
CC   = gcc
X
X.PHONY: all
all: raw
X
raw: raw.o rawread.o rawwrite.o
X	$(CC) $(LIBS) -s raw.o rawread.o rawwrite.o -o raw
X
raw.o: raw.c
X	$(CC) $(INCS) $(OPTS) -c raw.c
X
rawread.o: rawread.c
X	$(CC) $(INCS) $(OPTS) -c rawread.c
X
rawwrite.o: rawwrite.c
X	$(CC) $(INCS) $(OPTS) -c rawwrite.c
X
X.PHONY: clean
clean:
X	rm -f raw raw.o rawread.o rawwrite.o
X
X.PHONY: install
install: raw
X	gimptool --install-admin-bin raw
X
X.PHONY: install_user
install_user: raw
X	gimptool --install-bin raw
X
X.PHONY: unfold
unfold:
X	./rmfolds raw.h raw.c rawwrite.c rawread.c
X
SHAR_EOF
  $shar_touch -am 0714160298 'Makefile' &&
  chmod 0644 'Makefile' ||
  echo 'restore of Makefile failed'
  shar_count="`wc -c < 'Makefile'`"
  test 770 -eq "$shar_count" ||
    echo "Makefile: original size 770, current size $shar_count"
fi
# ============= README ==============
if test -f 'README' && test X"$1" != X"-c"; then
  echo 'x - skipping README (file already exists)'
else
  echo 'x - extracting README (text)'
  sed 's/^X//' << 'SHAR_EOF' > 'README' &&
X
X           ====================================================
X           HSI Raw plugin for The GIMP, version 0.1 (1998-7-14)
X           ====================================================
X
WHAT IS THIS <http://www.ee.oulu.fi/~tuukkat/releases.html>
------------
This is HSI Raw file version 4 read/write support plug-in for The GIMP.
X
X
COMPILING
---------
Type `make' and press enter. You may want to edit compile flags in
Makefile before this if you wish to or if you have problems.
X
X
INSTALLING
----------
Type `make install' and press enter. If you don't have root access,
use `make install_user' instead.
X
X
REQUIREMENTS
------------
The GIMP, everything what GIMP needs, ANSI C compiler and make program.
Tested on Linux 2.0.34, The GIMP 1.0, XFree 3.3.2 / X11R6.3,
Pentium 120MHz (x86 architecture), 24 MB memory, Image Alchemy v1.10.2d8.
X
X
BUGS / TODO
-----------
* Probably doesn't work on Cray (which has 64-bit char).
* Non-interactive mode not tested.
* Version 5 HSI Raw files not supported (they would contain alpha channel)
* Error messages should be more verbose.
X
X
WHAT IS THE GIMP <http://www.gimp.org>
----------------
GIMP is GNU Image Manipulation Program. It runs on Unix and compatible
operating systems, and is similar to Adobe PhotoShop (or should I say
that PhotoShop is similar to the GIMP ;) but better. And it's free.
X
X
WHAT IS IMAGE ALCHEMY <http://www.handmadesw.com>
---------------------
Image Alchemy is a image file converter which supports really _huge_
amount of different image formats. It is programmed and copyrighted by
Handmade Software, Inc.
X
It has a native file format called HSI Raw, which is very simple and
easy to process. Image Alchemy is a commercial product, but free limited
evalution versions may be downloaded from their web site. Various platforms
are supported, including Linux.
X
X
LICENSE
-------
What would you expect? GNU General Public License, of course.
Or at least GPL wannabe (I'm not a lawyer, see?).
X
X
CREDITS
-------
Copyright 1998 Tuukka Toivonen; based on BMP support plugin written
by <Alexander.Schulz@stud.uni-karlsruhe.de>; which in turn was based on
GIF plugin by Peter Mattis & Spencer Kimball and the PCX plugin by
Francisco Bustamante.
X
X
X                                         Signed,
X                                         Tuukka Toivonen <tuukkat@ee.oulu.fi>
X                                         http://www.ee.oulu.fi/~tuukkat/
X
SHAR_EOF
  $shar_touch -am 0715010798 'README' &&
  chmod 0644 'README' ||
  echo 'restore of README failed'
  shar_count="`wc -c < 'README'`"
  test 2419 -eq "$shar_count" ||
    echo "README: original size 2419, current size $shar_count"
fi
# ============= raw.c ==============
if test -f 'raw.c' && test X"$1" != X"-c"; then
  echo 'x - skipping raw.c (file already exists)'
else
  echo 'x - extracting raw.c (text)'
  sed 's/^X//' << 'SHAR_EOF' > 'raw.c' &&
X
/* raw.c - Copyright 1998 Tuukka Toivonen <tuukkat@ee.oulu.fi>
X */
X
#include <string.h>
#include <libgimp/gimp.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include "raw.h"
X
char *prog_name="raw";
gboolean interactive;
X
const char magic[6] = {0x6D, 0x68, 0x77, 0x61, 0x6E, 0x68}; /* or "mhwanh" */
X
/* Declare some local functions.
X */
static void query(void);
static void run(char    *name,
X                int      nparams,
X                GParam  *param,
X                int     *nreturn_vals,
X                GParam **return_vals);
X
GPlugInInfo PLUG_IN_INFO =
{
X    NULL,    /* init_proc   */
X    NULL,    /* quit_proc   */
X    query,   /* query_proc  */
X    run,     /* run_proc    */
};
X
MAIN ()
X
static void query (void)
{
X    static GParamDef load_args[] =
X    {
X        { PARAM_INT32,      "run_mode",     "Interactive, non-interactive" },
X        { PARAM_STRING,     "filename",     "The name of the file to load" },
X        { PARAM_STRING,     "raw_filename", "The name entered" },
X    };
X    static GParamDef load_return_vals[] =
X    {
X        { PARAM_IMAGE, "image", "Output image" },
X    };
X    static int nload_args = sizeof (load_args) / sizeof (load_args[0]);
X    static int nload_return_vals = sizeof (load_return_vals) / sizeof (load_return_vals[0]);
X
X    static GParamDef save_args[] =
X    {
X        { PARAM_INT32,      "run_mode",     "Interactive, non-interactive" },
X        { PARAM_IMAGE,      "image",        "Input image" },
X        { PARAM_DRAWABLE,   "drawable",     "Drawable to save" },
X        { PARAM_STRING,     "filename",     "The name of the file to save the image in" },
X        { PARAM_STRING,     "raw_filename", "The name entered" },
X    };
X    static int nsave_args = sizeof (save_args) / sizeof (save_args[0]);
X
X    gimp_install_procedure ("file_raw_load",
X                            "Loads files of HSI Raw file format",
X                            "Loads files of HSI Raw file format",
X                            "Tuukka Toivonen <tuukkat@ee.oulu.fi>",
X                            "Tuukka Toivonen <tuukkat@ee.oulu.fi>",
X                            "1998-7-14",
X                            "<Load>/HSI Raw",
X                            NULL,
X                            PROC_PLUG_IN,
X                            nload_args, nload_return_vals,
X                            load_args, load_return_vals);
X
X    gimp_install_procedure ("file_raw_save",
X                            "Saves files in HSI RAW file format",
X                            "Saves files in HSI RAW file format",
X                            "Tuukka Toivonen <tuukkat@ee.oulu.fi>",
X                            "Tuukka Toivonen <tuukkat@ee.oulu.fi>",
X                            "1998-7-14",
X                            "<Save>/HSI Raw",
X                            "INDEXED*, GRAY*, RGB*",
X                            PROC_PLUG_IN,
X                            nsave_args, 0,
X                            save_args, NULL);
X
X    gimp_register_magic_load_handler ("file_raw_load", "raw", "", "0,string,mhwanh");
X    gimp_register_save_handler ("file_raw_save", "raw", "");
}
X
static void run (char    *name,
X                 int      nparams,
X                 GParam  *param,
X                 int     *nreturn_vals,
X                 GParam **return_vals)
{
X    static GParam   values[2];
X    GStatusType     status;
X    GRunModeType    run_mode;
X    gint32          image_id;
X
X    status                  = STATUS_SUCCESS;
X    run_mode                = param[0].data.d_int32;
X    *nreturn_vals           = 1;
X    *return_vals            = values;
X    values[0].type          = PARAM_STATUS;
X    values[0].data.d_status = STATUS_CALLING_ERROR;
X
X    if (strcmp (name, "file_raw_load") == 0) {
X        switch (run_mode) {
X        case RUN_INTERACTIVE:
X            interactive = TRUE;
X            break;
X
X        case RUN_NONINTERACTIVE:
X            /*  Make sure all the arguments are there!  */
X            interactive = FALSE;
X            if (nparams != 3) status = STATUS_CALLING_ERROR;
X            break;
X
X        default:
X            break;
X        }
X
X        image_id = read_raw(param[1].data.d_string);
X
X        if (image_id != -1) {
X            *nreturn_vals = 2;
X            values[0].data.d_status = STATUS_SUCCESS;
X            values[1].type          = PARAM_IMAGE;
X            values[1].data.d_image  = image_id;
X        } else {
X            values[0].data.d_status = STATUS_EXECUTION_ERROR;
X        }
X    } else
X    if (strcmp (name, "file_raw_save") == 0) {
X        switch (run_mode) {
X        case RUN_INTERACTIVE:
X            interactive = TRUE;
X            break;
X
X        case RUN_NONINTERACTIVE:
X            /*  Make sure all the arguments are there!  */
X            interactive = FALSE;
X            if (nparams != 5) status = STATUS_CALLING_ERROR;
X            break;
X
X        case RUN_WITH_LAST_VALS:
X            interactive = FALSE;
X            break;
X
X        default:
X            break;
X        }
X
X        *nreturn_vals = 1;
X        if (write_raw(param[3].data.d_string, param[1].data.d_int32, param[2].data.d_int32)) {
X            values[0].data.d_status = STATUS_SUCCESS;
X        } else {
X            values[0].data.d_status = STATUS_EXECUTION_ERROR;
X        }
X    }
}
X
X
X
SHAR_EOF
  $shar_touch -am 0715005298 'raw.c' &&
  chmod 0644 'raw.c' ||
  echo 'restore of raw.c failed'
  shar_count="`wc -c < 'raw.c'`"
  test 5220 -eq "$shar_count" ||
    echo "raw.c: original size 5220, current size $shar_count"
fi
# ============= raw.h ==============
if test -f 'raw.h' && test X"$1" != X"-c"; then
  echo 'x - skipping raw.h (file already exists)'
else
  echo 'x - extracting raw.h (text)'
  sed 's/^X//' << 'SHAR_EOF' > 'raw.h' &&
X
/* raw.h - Copyright 1998 Tuukka Toivonen <tuukkat@ee.oulu.fi>
X */
X
#include <libgimp/gimp.h>
#include <glib.h>
X
#define READ_OK(file,buffer,len)  (fread((buffer), (len), 1, (file)) == 1)
#define WRITE(file,buffer,len)    fwrite((buffer), (len), 1, (file))
#define WRITE_OK(file,buffer,len) (WRITE((file), (buffer), (len)) == 1)
X
extern gint32 read_raw(char *filename);
extern int write_raw(char *filename, gint32 image, gint32 drawable_id);
X
extern gboolean interactive;
extern char *prog_name;
X
extern const char magic[6];
X
typedef struct HsiRawHdr {      /* 32 bytes when stored in file */
X    guint8  magic[6];
X    guint16 version;
X    guint16 width;
X    guint16 height;
X    gint16  palsize;
X
X    gint16 hdpi;
X    gint16 vdpi;
X    gint16 gamma;
X    guint16 compr;
X    guint8 reserved[10];
} HsiRawHdr;
X
X
X
SHAR_EOF
  $shar_touch -am 0715005298 'raw.h' &&
  chmod 0644 'raw.h' ||
  echo 'restore of raw.h failed'
  shar_count="`wc -c < 'raw.h'`"
  test 810 -eq "$shar_count" ||
    echo "raw.h: original size 810, current size $shar_count"
fi
# ============= rawread.c ==============
if test -f 'rawread.c' && test X"$1" != X"-c"; then
  echo 'x - skipping rawread.c (file already exists)'
else
  echo 'x - extracting rawread.c (text)'
  sed 's/^X//' << 'SHAR_EOF' > 'rawread.c' &&
X
/* rawread.c - Copyright 1998 Tuukka Toivonen <tuukkat@ee.oulu.fi>
X */
X
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgimp/gimp.h>
#include <gtk/gtk.h>
#include "raw.h"
X
static FILE *raw_open(char *name, HsiRawHdr *header);
static int read_int16(FILE *file);
X
/*
X * Read HSI Raw file from file `filename',
X * create a GIMP image and return image id.
X * If something goes wrong, return -1.
X */
gint32 read_raw(char *filename)
{
X    FILE            *file           = NULL;
X    HsiRawHdr       hdr;
X    gint32          image;
X    GImageType      image_type;
X    GDrawable       *drawable;
X    GDrawableType   drawable_type;
X    gint32          channels;
X    gint32          layer;
X    GPixelRgn       pixel_rgn;
X    guchar          *picture;
X    guchar          colormap[256*3];
X    guchar          lookup[256];
X    char            *buf;
X    int             i;
X
X    if (interactive) {
X        buf = g_malloc(strlen(filename) + 11);
X        sprintf(buf, "Loading %s:", filename);
X        gimp_progress_init(buf);
X        g_free(buf);
X    }
X
X    image_type = GRAY;
X
X    /* Is this a valid file? */
X    file = raw_open(filename, &hdr);
X    if (!file) goto broken_file;
X    if ((hdr.palsize == 0) || (hdr.palsize == -24)) {
X        image_type = RGB;
X        hdr.palsize = 0;
X    } else {
X        if ((hdr.palsize < 2) || (hdr.palsize > 256)) goto broken_file;
X    }
X    gimp_progress_update(0.10);
X
X    /* Get the Colormap */
X    if (image_type != RGB) {
X        if (!READ_OK(file, colormap, hdr.palsize*3)) goto broken_file;
X        for (i=0; i<hdr.palsize; i++) {
X            lookup[i] = 255*i / (hdr.palsize-1);
X            if ((colormap[i*3+0] != colormap[i*3+1]) ||
X                (colormap[i*3+0] != colormap[i*3+2]) ||
X                (colormap[i*3] != lookup[i]))
X            {
X                image_type = INDEXED;
X                break;
X
X            }
X        }
X    }
X    if (image_type == GRAY) {
X        for (i=hdr.palsize; i<256; i++) lookup[i] = hdr.palsize-1;
X    } else {
X        for (i=0; i<256; i++) lookup[i] = i;
X    }
X    gimp_progress_update(0.20);
X
X    /* Get the Image and return the ID or -1 on error*/
X    image = gimp_image_new(hdr.width, hdr.height, image_type);
X    gimp_image_set_filename(image, filename);
X    switch (image_type) {
X    case RGB:
X        drawable_type   = RGB_IMAGE;
X        channels        = 3;
X        break;
X    case GRAY:
X        drawable_type   = GRAY_IMAGE;
X        channels        = 1;
X        break;
X    case INDEXED:
X        drawable_type   = INDEXED_IMAGE;
X        channels        = 1;
X        break;
X    default:
X        goto broken_file;       /* We can never get here! */
X    }
X    layer = gimp_layer_new(image, "Background", hdr.width, hdr.height, drawable_type, 100, NORMAL_MODE);
X    gimp_image_add_layer(image, layer, 0);
X    drawable = gimp_drawable_get(layer);
X    picture = g_malloc(drawable->width * drawable->height * channels);
X    gimp_progress_update(0.30);
X
X    if (!READ_OK(file, picture, hdr.width*hdr.height*channels)) goto broken_file;
X    gimp_progress_update(0.80);
X    for (i=0; i<(hdr.width*hdr.height*channels); i++) picture[i] = lookup[picture[i]];
X    gimp_progress_update(0.90);
X
X    fclose(file);
X
X    gimp_pixel_rgn_init(&pixel_rgn, drawable, 0, 0, drawable->width, drawable->height, TRUE, FALSE);
X    gimp_pixel_rgn_set_rect(&pixel_rgn, picture, 0, 0, drawable->width, drawable->height);
X    if (image_type != RGB) gimp_image_set_cmap(image, colormap, hdr.palsize);
X    gimp_drawable_flush(drawable);
X    gimp_drawable_detach(drawable);
X
X    gimp_progress_update(1.0);
X    g_free(picture);
X    return image;
X
broken_file:
X    if (file) fclose(file);
X    printf("%s: not valid HSI Raw file \"%s\"\n", prog_name, filename);
X    return -1;
}
X
X
X
/* Open HSI Raw file and store header to hdr if not NULL.
X * Position file right after header.
X * Return FILE if succesful, NULL otherwise.
X */
static FILE *raw_open(char *filename, HsiRawHdr *header)
{
#if 0
X    HsiRawHdr tmphdr;
#endif
X    FILE *f;
X    int r;
X
#if 0
X    if (!header) header = &tmphdr;
#endif
X    f = fopen(filename, "rb");
X    if (!f) return NULL;
X
X    r = fread(&(header->magic), 1, sizeof(header->magic), f);
X    if (r != sizeof(header->magic))     { fclose(f); return NULL; }
X    if (memcmp(&(header->magic), &magic, sizeof(magic))) { fclose(f); return NULL; }
X
X    if ((r=read_int16(f)) == -1)        { fclose(f); return NULL; }
X    header->version = r;
X    if (header->version != 4)           { fclose(f); return NULL; }
X
X    if ((r=read_int16(f)) == -1)        { fclose(f); return NULL; }
X    header->width = r;
X
X    if ((r=read_int16(f)) == -1)        { fclose(f); return NULL; }
X    header->height = r;
X
X    if ((r=read_int16(f)) == -1)        { fclose(f); return NULL; }
X    header->palsize = r;
X
X    if ((r=read_int16(f)) == -1)        { fclose(f); return NULL; }
X    header->hdpi = r;
X
X    if ((r=read_int16(f)) == -1)        { fclose(f); return NULL; }
X    header->vdpi = r;
X
X    if ((r=read_int16(f)) == -1)        { fclose(f); return NULL; }
X    header->gamma = r;
X
X    if ((r=read_int16(f)) == -1)        { fclose(f); return NULL; }
X    header->compr = r;
X    if (header->compr != 0)             { fclose(f); return NULL; }
X
X    r = fread(&(header->reserved), 1, sizeof(header->reserved), f);
X    if (r != sizeof(header->reserved))  { fclose(f); return NULL; }
X
X    return f;
}
X
X
/* Read integer from file in Image Alchemy format (2 bytes, high byte first)
X * Return -1 if failed.
X */
static int read_int16(FILE *file)
{
X    int i1, i2;
X
X    i1 = getc(file);
X    if (i1 == EOF) return -1;
X    i2 = getc(file);
X    if (i2 == EOF) return -1;
X    return (i2&0xFF) | ((i1&0xFF) << 8);
}
X
X
X
SHAR_EOF
  $shar_touch -am 0715005298 'rawread.c' &&
  chmod 0644 'rawread.c' ||
  echo 'restore of rawread.c failed'
  shar_count="`wc -c < 'rawread.c'`"
  test 5671 -eq "$shar_count" ||
    echo "rawread.c: original size 5671, current size $shar_count"
fi
# ============= rawspecs.txt ==============
if test -f 'rawspecs.txt' && test X"$1" != X"-c"; then
  echo 'x - skipping rawspecs.txt (file already exists)'
else
  echo 'x - extracting rawspecs.txt (text)'
  sed 's/^X//' << 'SHAR_EOF' > 'rawspecs.txt' &&
X
X          [ This description is from Image Alchemy v1.5 manual;
X            Copyright (c) 1990-91 Handmade Software Inc.        ]
X
X
X          HSI Raw Files
X          -----------------------------------------------------------------
X
X
X          History          The HSI Raw format was originally intended as an
X                           internal format to Image Alchemy.  Because of
X                           user demand the format has been documented to
X                           allow others to read and write HSI Raw files.
X
X          Overview         HSI Raw files are completely uncompressed,
X                           unpacked, and unpadded image data files.
X                           Therefore they tend to be larger than almost any
X                           compressed file format.  However, they have the
X                           advantage, as far as Alchemy is concerned, that
X                           they are very fast to read and write and the
X                           location of any pixel in the image may be found
X                           by simple calculations.
X
X                           If you need to convert custom files to a format
X                           that Alchemy can read we recommend using a Raw
X                           file; it is the simplest format to write and the
X                           fastest for Alchemy to read.
X
X          Variations       There are two types of HSI Raw Files:  paletted
X                           and true colour.  Paletted images are stored one
X                           byte per pixel with a palette at the beginning
X                           of the file.  True colour files are stored three
X                           bytes per pixel.
X
X               Gray-scale  Gray scale files are stored as paletted files
X                           with a palette that contains all gray values.
X                           Alchemy automatically recognizes such files
X                           during reading and will treat them
X                           appropriately.
X
X          Black and white  Black and White files are stored as paletted
X                           files with a palette that contains two values,
X                           black and white.  Alchemy automatically
X                           recognizes such files during reading and will
X                           treat them appropriately.
X
X          Warning          Note that Handmade Software, Inc. reserves the
X                           right to make changes to this format at any time
X                           and without notice.  And while it is unlikely,
X                           it is possible that future versions of Image
X                           Alchemy will not support this format.
X
X          Old version      This appendix describes version 4 Raw files.
X          files            This is the version that Image Alchemy has
X                           written since March 1991.  Before this Alchemy
X                           wrote version 2 and 3 raw files (version 2 were
X                           8 bit files, version 3 were 24 bit files).
X                           Those raw files can be read by current versions
X                           of Image Alchemy but are not otherwise
X                           supported.  If you run across any of these raw
X                           files the easiest thing to do is to use a
X                           current copy of Alchemy to convert them to a
X                           version 4 raw file.
X
X
X
X          Details
X
X                Word size  All values which are not otherwise identified
X                           are two byte integers (16 bits).  This is the
X                           native integer size of most IBM PC C-compilers
X                           but not for Macintosh and Sun C-compilers.
X
X               Byte order  All integers are stored high byte first (big-
X                           endian order).  This is the native mode for
X                           Macintosh's and Sun's but not the native mode
X                           for IBM PC's.
X
X                           See below for a CPU independent method to read
X                           and write 2-byte integers.
X
X             Pixel format  Paletted files are stored one byte per pixel.
X
X                           True colour files are stored as three bytes per
X                           pixel in red, green, blue order.
X
X                  Padding  Neither the palette information nor the pixel
X                           data is padded to anything other than a byte
X                           boundary.  This means that if you store a file
X                           which is 13 by 11 pixels it will occupy 429
X                           bytes if stored as a true colour file (not
X                           including the header), or 143 bytes if stored as
X                           a paletted file (not including the header and
X                           palette data).
X
X                      Hex  Numbers including a 0x prefix are hex; all other
X                           numbers are decimal.
X
X
X
X          File format      The header for a paletted file is 32 bytes plus
X                           the size of the palette.  The header for a true
X                           colour file is exactly 32 bytes (a true colour
X                           file contains no palette).
X
X             Magic number  Six bytes used to identify the file as a HSI Raw
X                           file:
X
X                                0x6d 0x68 0x77 0x61 0x6e 0x68
X
X                  Version  An integer used to identify the version HSI
X                           file:
X
X                                0x0004
X
X                    Width  An integer indicating the width of the image (in
X                           pixels).
X
X                   Height  An integer indicating the height of the image
X                           (in pixels).
X
X             Palette size  An integer indicating the number of entries in
X                           the palette.  Range is 2 to 256.  A 0 indicates
X                           a true colour image (which has no palette data).
X
X           Horizontal DPI  An integer indicating the horizontal resolution
X                           of the image, in dots per inch.  A zero
X                           indicates that the resolution is unknown.  A
X                           negative number is used if only the aspect ratio
X                           is known.
X
X             Vertical DPI  An integer indicating the vertical resolution of
X                           the image, in dots per inch.  A zero indicates
X                           that the resolution is unknown.  A negative
X                           number is used if only the aspect ratio is
X                           known.
X
X                    Gamma  An integer indicating the gamma of the image,
X                           scaled by 100 (a gamma of 2.2 is stored as 220).
X                           A zero indicates that the gamma is not known.
X
X                 Reserved  Twelve bytes reserved for future use.  Should be
X                           set to zero when writing.
X
X                  Palette  The palette data is stored as 3 bytes per
X                           palette entry.  The bytes are in red, green,
X                           blue order; 0 is black, 0xff is full intensity.
X
X                           True colour raw files have no palette.
X
X               Image data  The image data.
X
X
X
SHAR_EOF
  $shar_touch -am 0714144098 'rawspecs.txt' &&
  chmod 0644 'rawspecs.txt' ||
  echo 'restore of rawspecs.txt failed'
  shar_count="`wc -c < 'rawspecs.txt'`"
  test 7487 -eq "$shar_count" ||
    echo "rawspecs.txt: original size 7487, current size $shar_count"
fi
# ============= rawwrite.c ==============
if test -f 'rawwrite.c' && test X"$1" != X"-c"; then
  echo 'x - skipping rawwrite.c (file already exists)'
else
  echo 'x - extracting rawwrite.c (text)'
  sed 's/^X//' << 'SHAR_EOF' > 'rawwrite.c' &&
X
/* rawwrite.c - Copyright 1998 Tuukka Toivonen <tuukkat@ee.oulu.fi>
X */
X
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <libgimp/gimp.h>
#include "raw.h"
X
int write_int16(gint16 i, FILE *file);
X
/*
X * Save HSI Raw file from `image' and `drawable_id' using filename `filename'.
X * If something goes wrong, return zero, nonzero if everything is ok.
X */
int write_raw(char *filename, gint32 image, gint32 drawable_id)
{
X    FILE            *file           = NULL;
X    HsiRawHdr       hdr;
X    GDrawable       *drawable;
X    GDrawableType   drawable_type;
X    GPixelRgn       pixel_rgn;
X    guchar          *cmap           = NULL;
X    guchar          *picture;
X    int             channels        = 0;
X    char            *buf;
X    int             i;
X
X    /* Show progress bar */
X    if (interactive) {
X        buf = g_malloc(strlen(filename) + 11);
X        sprintf(buf, "Saving %s:", filename);
X        gimp_progress_init(buf);
X        g_free(buf);
X    }
X
X    /* Initialize something */
X    drawable = gimp_drawable_get(drawable_id);
X    drawable_type = gimp_drawable_type(drawable_id);
X    gimp_pixel_rgn_init(&pixel_rgn, drawable, 0, 0, drawable->width, drawable->height, FALSE, FALSE);
X    gimp_progress_update(0.10);
X
X    /* Set up HSI Raw file header */
X    memset(&hdr, 0, sizeof(hdr));
X    memcpy(&hdr.magic, magic, sizeof(hdr.magic));
X    hdr.version = 4;
X    switch (drawable_type) {
X    case RGB_IMAGE:
X        channels = 3;
X        break;
X    case GRAY_IMAGE:
X        channels = 1;
X        hdr.palsize = 256;
X        break;
X    case INDEXED_IMAGE:
X        channels = 1;
X        cmap = gimp_image_get_cmap(image, &i);
X        hdr.palsize = (gint16)i;
X        break;
X    default:
X        printf("raw: cannot operate on unknown image types or alpha images");
X        gimp_quit();
X        break;
X    }
X    hdr.width = drawable->width;
X    hdr.height = drawable->height;
X    gimp_progress_update(0.20);
X
X    /* Write the header into the file */
X    file = fopen(filename, "wb");
X    if (!WRITE_OK(file, &hdr.magic, sizeof(hdr.magic))) goto error;
X    if (write_int16(hdr.version, file)) goto error;
X    if (write_int16(hdr.width, file)) goto error;
X    if (write_int16(hdr.height, file)) goto error;
X    if (write_int16(hdr.palsize, file)) goto error;
X    if (write_int16(hdr.hdpi, file)) goto error;
X    if (write_int16(hdr.vdpi, file)) goto error;
X    if (write_int16(hdr.gamma, file)) goto error;
X    if (write_int16(hdr.compr, file)) goto error;
X    if (!WRITE_OK(file, &hdr.reserved, sizeof(hdr.reserved))) goto error;
X    gimp_progress_update(0.30);
X
X    /* Write palette */
X    switch (drawable_type) {
X    case GRAY_IMAGE:
X        for (i=0; i<256; i++) {
X            if (putc(i, file) == EOF) goto error;
X            if (putc(i, file) == EOF) goto error;
X            if (putc(i, file) == EOF) goto error;
X        }
X        break;
X    case INDEXED_IMAGE:
X        for (i=0; i<hdr.palsize; i++) {
X            if (putc(cmap[i*3+0], file) == EOF) goto error;
X            if (putc(cmap[i*3+1], file) == EOF) goto error;
X            if (putc(cmap[i*3+2], file) == EOF) goto error;
X        }
X        break;
X    default:
X    }
X    gimp_progress_update(0.40);
X
X    /* Write image pixels */
X    picture = (guchar *)g_malloc(hdr.width * hdr.height * channels);
X    gimp_pixel_rgn_get_rect(&pixel_rgn, picture, 0, 0, hdr.width, hdr.height);
X    gimp_progress_update(0.50);
X
X    if (!WRITE_OK(file, picture, hdr.width * hdr.height * channels)) goto error;
X
X    gimp_progress_update(1.0);
X    return 1;
X
error:
X    if (file) {
X        fclose(file);
X        remove(filename);
X    }
X    printf("%s: write error", prog_name);
X    return 0;
}
X
X
/* Write a 16-bit integer to file in HSI Raw byte order
X * (most significand byte first).
X * Return zero if everything gone well, nonzero otherwise.
X */
int write_int16(gint16 i, FILE *file)
{
X    if (putc((i >> 8) & 0xFF, file) == EOF) return -1;
X    if (putc(i & 0xFF, file) == EOF) return -1;
X    return 0;
}
X
X
X
SHAR_EOF
  $shar_touch -am 0715005298 'rawwrite.c' &&
  chmod 0644 'rawwrite.c' ||
  echo 'restore of rawwrite.c failed'
  shar_count="`wc -c < 'rawwrite.c'`"
  test 4015 -eq "$shar_count" ||
    echo "rawwrite.c: original size 4015, current size $shar_count"
fi
# ============= rmfolds ==============
if test -f 'rmfolds' && test X"$1" != X"-c"; then
  echo 'x - skipping rmfolds (file already exists)'
else
  echo 'x - extracting rmfolds (text)'
  sed 's/^X//' << 'SHAR_EOF' > 'rmfolds' &&
#!/bin/sh
X
# This script removes "[fold]" lines from argument files.
# Folds are very useful when using Aurora editor, but
# with other editors they may be a little annoying.
X
while [ "$1" != "" ]; do
X    echo "Removing folds from file $1"
X    grep -v " \[fold\]  " "$1" >/tmp/TMPREMOVEFOLDS
X    mv -f /tmp/TMPREMOVEFOLDS "$1"
X    shift 1
done
X
SHAR_EOF
  $shar_touch -am 0502222098 'rmfolds' &&
  chmod 0755 'rmfolds' ||
  echo 'restore of rmfolds failed'
  shar_count="`wc -c < 'rmfolds'`"
  test 345 -eq "$shar_count" ||
    echo "rmfolds: original size 345, current size $shar_count"
fi
exit 0
