#!/usr/bin/perl 

use Gimp qw(:auto); 
use Gimp::Net; 

$cat = "/bin/cat";
$sed = "/bin/sed";
$head = "/usr/bin/head";
$find = "/usr/bin/find";
$rand = "/usr/local/bin/rand";
$setrootbg = "/usr/local/bin/wmsetbg -e";

$homedir = $ENV{'HOME'};
$bglist = $homedir . "/.bglist";
$bgfile = $homedir . "/.bgfile";
$bgscaled = $homedir . "/.bgscaled.jpg";
$bgdir = "/usr/local/share/WindowMaker/Backgrounds/";

$width = 1024;
$height = 768;
$sleep_time = 3600;

sub gimp_bg {

#    do {

    if ($#ARGV >= 0) {
	$bgfilename = $ARGV[0];
    }
    else {
	system("cd \"$bgdir\" && $find -name \*.jpg | $sed s-./-\"$bgdir\"- >\"$bglist\"") if (!(-e $bglist));
	system("$cat \"$bglist\" | $rand | $head -n 1 >\"$bgfile\"");
	open(BGFILENAME, "$bgfile") || die("can't open \"$bgfile\"");
	$bgfilename = <BGFILENAME>;
	chop($bgfilename);
	close(BGFILENAME);
    }
    
    $img = file_jpeg_load($bgfilename, $bgfilename);
    ($img_width, $img_height) = (gimp_image_width($img), gimp_image_height($img));
    if (($width != $img_width) || ($height != $img_height)) {
	if ($img_width > $img_height) {
	    ($new_width, $new_height) = ($width, $width * $img_height / $img_width);
	}
	elsif ($img_height > $img_width) {
	    ($new_width, $new_height) = ($height * $img_width / $img_height, $height);
	}
	else {
	    ($new_width, $new_height) = ($width, $height);
	}
	gimp_image_scale($img, $new_width, $new_height);
	$drawable = gimp_image_active_drawable($img);
	file_jpeg_save($drawable, $bgscaled, $bgscaled, 0.8, 0.0, 0, 0, "Scaled By GiMP/gimp-bg");
	system("$setrootbg \"$bgscaled\"");
    }
    else {
	system("$setrootbg \"$bgfilename\"");
    }

#    } while (($#ARGV < 0) && sleep($sleep_time));

}

sub net {
    gimp_bg;
}

exit main;  
