#!/usr/bin/perl  -w
#(o)1999 Wayne Keenan

use Gimp qw(:auto);
use Gimp::Fu;
use Gimp::Util;
use PDL::LiteF;


register
  
  "perl_fu_waffler",
  "cut up an RGB image into: 
      1) individual image tiles,       
      2) montage of all the tiles,  and 
      3) image with 1 layer for each tile", 
"
NOTE: ALPHA RELEASE
      

      Please see what missing, and what might nice, the TODOs below.

      Please contact me if you really want any of the TODO features desperately.
     
      Please feel free to use this as a basis for other plugins.

       

      Non-appearing guest stars, in no particular order:

TODO: help text

TODO: fix pixel color check to check for colors other than black  (this is severely bodged!)

TODO: more sanity checks: filenames,sizes, excess bounds, ludicrous sizes, phase of the moon

TODO: add tile x,y pos (used for neigbour information/other)

TODO: add the option to not delete the images if they are undisplayed
      I could fore see a time when one would like the images available, but not cluttering the screen

TODO: the progress indicators are not implemented properly yet.

TODO: Montage is only horizontal with no spacing, need to add other options.

TODO: Could make montage plotting behaviour a user defined callback/formula based.

TODO: add smart chopping (auto Horz/Vert alignent based on the Cutter Colour)

TODO: add an over-grab/under-grab option for tiles at the border of the  selection/image

TODO: add neigbourhood calculations and output, will probaly drop this in favour
      of a simple: tile_name came-from img(x pos,y pos) format, and let the application
      specific code process the co-ords in its own unique way.

TODO: trap errors (e.g. when saving files) and do a proper image clearup

TODO: create an HTML table to reconstruct the original (or for image map, hmmmm)

TODO: Correctly suport Indexed images

TODO: Improved auto conversion (more types & need a better file format abilities interegator)

TODO: many optimisation , esp, constant folding the tile List usage

TODO: ad optional output to some for of DB, (this is probably over kill!)

TODO: MAJOR overhaul: as this was a learning exercise for me the next
      step is learn how to use PDL properly and re-write 'waffle' using that,
      and of course use all the funky matrix manipulations that go with it, in someway, SPEED!, and
      virtual child piddles would be able to update the original image if desired,
      dont think that that will work across network boundries, something I read in the docs,
      but hopefully I'm wrong.
      
---------------------------------------------------------------------------------------------------------
Tr!p!x  - wk\@ecs.soton.ac.uk

  ",
  "Tr!p!x (wk\@ecs.soton.ac.uk)", 
  "(o)1999 Trance, Dance, & Intoxication",
  "1999-08-12",
  "<Image>/Filters/Map/Waffler",
  "RGB",
  [
   [PF_RADIO  ,"Work Area", "Area to be processed", 1 , [ "Whole Image" =>0, Selection =>1]],

   [PF_COLOR,  "Chop Colour",  "colour to base waffler on (unused)", [0, 0, 0]],
   [PF_BOOL  , "Discard Empty Tiles",  "Throw away tiles containing pixels which all the Chop Colour" , 1],
   
   [PF_BOOL  , "Translate Origin",  "Offset the work origin by:   " , 0],
   [PF_SPINNER,"Origin X Offset", "Offset X origin by N pixels" , 0, [-2**30,2**30,1]],
   [PF_SPINNER,"Origin Y Offset", "Offset Y origin by N pixels" , 0, [-2**30,2**30,1]],

   [PF_SLIDER, "Tile X Size", "tile width",  16, [0, 255, 1] ],
   [PF_SLIDER, "Tile Y Size", "tile height", 16, [0, 255, 1] ],
   [PF_SLIDER, "Tile X Seperation", "tile seperation border width",  0, [0, 127, 1] ],
   [PF_SLIDER, "Tile Y Sereration", "tile seperation border height", 0, [0, 127, 1] ],


   [PF_BOOL  , "Generate Tiles",     "Generates the found tiles as individual images", 0],
   [PF_BOOL  , "Generate Montage",   "Generates a montage containing all the found tiles", 0],
   [PF_BOOL  , "Generate as Layered","Generates tiles as one single image in seperate layers (for a Gimp animation plugin) ", 0],

   [PF_RADIO,  "Montage direction",  "the direction to arange the Montage",  1, [Horizontal => 1,  
										 Vertical   => 2, 
										 Both       => 3]
   ],

   [PF_SLIDER, "Montage Tile X Seperation", "Tile seperation border width",  0, [0, 255, 1] ],
   [PF_SLIDER, "Montage Tile Y Seperation", "Tile seperation border height", 0, [0, 255, 1] ],


   [PF_BOOL  , "Display Tiles",      "Display ALL the found tiles as seperate images in the Gimp (warning, ALL might = LOTS!)", 0],
   [PF_BOOL  , "Display Montage",    "Display the montage in the Gimp", 1],
   [PF_BOOL  , "Display Layered",    "Display the layered image in the Gimp" , 1],

   [PF_STRING, "Tile name prefix",   "Prefix tile filenames with this string", "tile_"], 
   [PF_STRING, "Tile file type",     "Set the tile filetype (e.g. gif, jpg, png, xcf)", "gif"], 
   [PF_FILE  , "Genereate Tiles in Directory",  "Directory to save File(s) in", "/tmp"] ,
   [PF_FILE  , "Generate Montage as",   "File location (including your choice of file type extension)", "/tmp/tiles-montage.xcf"],
   [PF_FILE  , "Genereate  Layered as", "File location (including your choice of file type extension)" , "/tmp/tiles-layered.xcf" ],

   [PF_BOOL  , "Generate Info File", "Generates an info file containing 8 way neighbour information (e.g for a Map Designer) "],


   #add exteral DB receipient options here (hostname, port, db name, user, pw etc...) , will be a DBI database
  ],
  [
   [PF_IMAGE, "image", "Resulting Image(s)"],
  ],
  [], # feature check
  \&waffler;


# It might be useful to know that if you change the plug-in
# interface then you might find it useful to look at the file:
# 'parasiterc', in the gimp config directory(ies)
# it contains an autogenerated (on gimp exit) plugin-settings, you might find it useful to delete entries 
# contained in it which for releate to your development plugin when you change your interface.
#
# perhaps the Gimp should check the time-stamp of the plugin executable, and offer to delete 
# the settings after detecting a change in the time-stamp?
#########################################################################################################


sub waffler
{ 
    
    my ($orgImg, $orgLayer, 
	
	$useSelection,
	$cutCol,

	$discardEmptyTiles,
	
	$useOrgOffset,
	$originXOffset,  $originYOffset,

	$tileSizeX,      $tileSizeY,
	$tileSepX,       $tileSepY,

	$genTiles,
	$genMontage,
	$genLayered,
	
	$montageDir,
	$montageSepX,    $montageSepY,

	$dispTiles,
	$dispMontage,
	$dispLayered,

	$tileNamePrefix,
	$tileFileExt,
	$tileSaveDir,
	$montageFile,
	$layeredFile,

	$genInfoFile,
       
	
       ) = @_;

    ####################################################################################################################

    # lets do some sanity checks first:

    my ($hasSelection, $selMinX, $selMinY, $selMaxX, $selMaxY,  )= $orgLayer->mask_bounds;


    my $setupErrorMessages="";
    my $errNum=1;
   
    if ($useSelection and not $hasSelection)
    {
	$setupErrorMessages.=$errNum++.".  There is no selection, and I have not been told to operate on the whole image.\n";
	
    }

    if ($genTiles and $tileSaveDir eq "")
    {
	$setupErrorMessages.=$errNum++.".  Please specify the Tile save directory\n";
    }

    if ($genMontage and $montageFile eq "")
    {
	$setupErrorMessages.=$errNum++.".  Please specify the Montage filename\n";
    }

    if ($genLayered and $layeredFile eq "")
    {
	$setupErrorMessages.=$errNum++.".  Please specify the Layered filename\n";
      
    }

    if ($setupErrorMessages ne "")
    {
	gimp_message("Opps, the Waffler detects that there \nare some slight config problem(s):\n\n$setupErrorMessages");
	return (0);
    }


    ####################################################################################################################


    my $oldState = get_state();                        # dont piss of the user!

    #get some info about the original:

    #the image
    my $orgImgWidth      = $orgImg->image_width ;
    my $orgImgHeight     = $orgImg->image_height;
    my $orgImgType       = $orgImg->base_type;

    #the layer 
    my $orgLayerBytes    = $orgLayer->drawable_bytes;
    my $orgLayerMode     = $orgLayer->get_mode; 
    my $orgLayerName     = $orgLayer->get_name; 
    my $orgLayerOpacity  = $orgLayer->get_opacity;
    my $orgLayerType     = $orgImgType;               #layers are always their same type as the base image
    
    ####################################################################################################################

    #vars
    my @tileList=();                     #list of tiles
    my @discardedTileList=();            #list of discardable tiles (blank ones) (could be deleted)
    my $foundTiles=0;                    #count of found tiles
    my $montageImg=undef;                
    my $layeredImg=undef;                


    my ($initX, $initY, 
	$stepX, $stepY,
	$sizeX, $sizeY, 
	$limitX, $limitY
	) = (
	     undef, undef,
	     $tileSizeX+$tileSepX, $tileSizeY+$tileSepY,
	     $tileSizeX,$tileSizeY,
	     undef, undef
	     );      


    if ($useSelection)        # set waffle limits to the rectangular selection
    {
	($initX, $initY, $limitX, $limitY)    = (
						 $selMinX, $selMinY,
						 $selMaxX, $selMaxY
						 );
    }
    else                      # set waffle limits to the whole image 
    {
	($initX, $initY, $limitX, $limitY)    = ( 
						  0,0, 
						  $orgImgWidth, $orgImgHeight
						);
      }
    
										
    if ($useOrgOffset)        # translate origin 
      {
	($initX, $initY, $limitX, $limitY)  =	(
						 $initX +$originXOffset, 
						 $initY +$originYOffset, 
						 $limitX+$originXOffset, 
						 $limitY+$originYOffset
						);

      }

    #add over grab/ubder grab work area adjustments here

    ##############################################################################
    ##### Main Tile extraction processing
    
    Gimp->progress_init ("Waffling Image...");

    #currently will grab tiles which poke outside the work area.
    for ( my $curY = $initY;  ($curY) <= $limitY; $curY+=$stepY)
    {
	for ( my $curX = $initX;  ($curX) <= $limitX; $curX+=$stepX)
	{
	    my @srcRgnBounds = ($curX, $curY, $sizeX, $sizeY);
	    my @dstRgnBounds = (0, 0, $sizeX, $sizeY);
	    my $cutPixelCount= 0;


	    my $dstImg    = gimp_image_new($sizeX, $sizeY, $orgImgType);     

	    my $dstLayer  = $dstImg->layer_new($sizeX, $sizeY, 
					       $orgLayerType,    "$tileNamePrefix$foundTiles", 
					       $orgLayerOpacity, $orgLayerMode); 
	    $dstImg->add_layer($dstLayer,-1);

            #now we start dealing with pixel data 

	    my $src = new PixelRgn ($orgLayer->get,@srcRgnBounds,0,0);
	    my $dst = new PixelRgn ($dstLayer->get,@dstRgnBounds,1,0);	    	    

	    my $iter = Gimp->pixel_rgns_register ($src, $dst);


	    #loop through the pixels in a waffle tile  
	    do 
	    {
		my $pixels = $src->data;

		if ($discardEmptyTiles)
		{
		    for (list $pixels) 
		    {
			$cutPixelCount++ if $_ ==0;  #THIS IS A F**K-WIT BODGE!!:
		    }
		}	      

		$dst->data($pixels);		

	    } 
	    while (Gimp->pixel_rgns_process ($iter));
	    
	    undef $iter;

	    $dstLayer->update (@dstRgnBounds);	
	    $dstImg->clean_all();                                           #clear the dirty flag (i.e. the new tile is not considered 'modified' by the Gimp)
	    
	    if ( $cutPixelCount == ($sizeX*$sizeY*$orgLayerBytes))          #dont include the tile if all pixels are the chop colour
	    {
		push (@discardedTileList, $dstImg);                         #excplicitly delete them later
		
	    }
	    else                                                            #otherwise we want it
	    {
		$foundTiles++;
		push (@tileList, $dstImg);                                  #we need to delete these if they are displayed to the Gimp
	    }
	    
	    eval # to catch DIV0
	    {
		Gimp->progress_update ( abs($sizeX*$sizeY*$foundTiles) / (  abs(($limitX-$initX) * ($limitY - $initY) )*$foundTiles) )  ;  
	    };
	    
	}
    }
    Gimp->progress_update (1);
    
    

    ####################################################################################################################
    # create the montage
    
    
    if ($genMontage or $dispMontage)
    {
	my $montageWidth  = $foundTiles*$sizeX;
	my $montageHeight = $sizeY;
      	my $montageXPos=0; 
	my $montageYPos=0;   

	$montageImg    = gimp_image_new(
					$montageWidth, 
					$montageHeight, 
					$orgImgType
					);     
	
	my $montageLayer  = $montageImg->layer_new(
						   $montageWidth,    $montageHeight, 
						   $orgLayerType,    "Montage Layer", 
						   $orgLayerOpacity, $orgLayerMode
						   ); 
	$montageImg->add_layer($montageLayer,0);


	
	Gimp->progress_init ("Creating Montage...");
	
	foreach my $tempTile (@tileList)
	{
	    my @tempTileLayers=$tempTile->get_layers();
	    my $tempTileLayer= shift @tempTileLayers;

	    my @srcRgnBounds = (0, 0, $sizeX, $sizeY);
	    my @dstRgnBounds = ($montageXPos, $montageYPos, $sizeX, $sizeY);
	    
	    $montageXPos+=$sizeX;  
	    
	    my $src = new PixelRgn ($tempTileLayer->get, @srcRgnBounds,0,0);
	    my $dst = new PixelRgn ($montageLayer->get,  @dstRgnBounds,1,0);
	    
	    my $iter = Gimp->pixel_rgns_register ($src, $dst);

	    do 
	    {
		$dst->data($src->data);                  #straight copy
	    } 
	    while (Gimp->pixel_rgns_process ($iter));
	    
	    $montageLayer->update (@dstRgnBounds);	
	    
	    eval { Gimp->progress_update ( ($montageXPos/$montageWidth)  ); }; 
	  }
	$montageImg->clean_all();   
	Gimp->progress_update (1);
    }
    
    #######################################################################################################
    # create the Layered verion

    
    if ($genLayered or $dispLayered)
    {

	my $layeredWidth  = $sizeX;
	my $layeredHeight = $sizeY;

	$layeredImg    = gimp_image_new(
					$layeredWidth, 
					$layeredHeight, 
					$orgImgType
					);     
		
	Gimp->progress_init ("Creating Layered...");
	
	foreach my $tempTile (reverse @tileList)
	{
	    
	    my $layeredLayer  = $layeredImg->layer_new(
						   $layeredWidth,    $layeredHeight, 
						   $orgLayerType,    get_layer_name($tempTile,0), 
						   $orgLayerOpacity, $orgLayerMode
						   ); 

	    $layeredImg->add_layer($layeredLayer,-1);

	    
	    my @tempTileLayers=$tempTile->get_layers();
	    my $tempTileLayer= shift @tempTileLayers;

	    my @srcRgnBounds = (0, 0, $sizeX, $sizeY);
	    my @dstRgnBounds = (0, 0, $sizeX, $sizeY);
	    
	    
	    my $src = new PixelRgn ($tempTileLayer->get, @srcRgnBounds,0,0);
	    my $dst = new PixelRgn ($layeredLayer->get,  @dstRgnBounds,1,0);
	    
	    my $iter = Gimp->pixel_rgns_register ($src, $dst);

	    do 
	    {
		$dst->data($src->data);                      # just plain copy I'm affraid
	    } 
	    while (Gimp->pixel_rgns_process ($iter));

	    $layeredLayer->add_alpha;                        # do this after adding non-alpha Tiles	    
	                                                     # only added because of he Anim Layer plugin
	    $layeredLayer->update (@dstRgnBounds);	
	    
	    eval { Gimp->progress_update (); };             
	  }
	$layeredImg->clean_all();                            #clear the dirty flag 
	Gimp->progress_update (1);
    }

    

    #######################################################################################################
    #create neighbour table
   

    #######################################################################################################
    # save stuff to disc
    

    if ($genTiles)
    {
	foreach my $tempTile (@tileList)
	{
	    my $tileName= get_layer_name ($tempTile,0);
	    my $fileName= "$tileSaveDir/$tileName.$tileFileExt";

	    
	    #must be a better way to get info on a proposed file save (with conversion)
	    #i.e. be able to call gimp_file_save in a query mode about the image file format in the extension

	    #TODO check OK to auto convert
	    #TODO: add more file types
	    if  ($tileFileExt =~ /gif$/s)
	    {
		$tempTile->convert_indexed(0,255);   # typical for a webby giffy
	    }

	    $tempTile->gimp_file_save(-1,                    
					 $fileName,
					 $fileName
					 );
	}
    }

    if ($genMontage)
    {
	$montageImg->gimp_file_save(-1, 
				    $montageFile,
				    $montageFile
				   );       			    
    }
    
    if ($genLayered)
    {
	my @tempLayers=$layeredImg->get_layers();   

	$layeredImg->gimp_file_save(-1,
				    $layeredFile,
				    $layeredFile,
				    );
    }

    if ($genInfoFile)
    {
    }
    

    #######################################################################################################
    #TODO:send pixel data to an external database, with context (i.e info file, original image)





   

    #######################################################################################################
    # clean up of the undisplyed images (dont piss off the user by filling the img list with unwanted shit!)
    
    foreach my $tempTile (@discardedTileList)
    {
	$tempTile->delete;
    }
    
    if (not $dispTiles)
    {
	foreach my $tempTile (@tileList)
	{
	    $tempTile->delete;
	}
    }
    
    if (defined($montageImg) and not $dispMontage)
    {
	$montageImg->delete;
    }
    
    if (defined($layeredImg) and not $dispLayered)
    {
	$layeredImg->delete;
    }

    #######################################################################################################
    # Return the image (s)

    my @returnList=();

    push (@returnList, $montageImg) if $dispMontage;
    push (@returnList, $layeredImg) if $dispLayered;
    push (@returnList, @tileList)   if $dispTiles;

    set_state($oldState);                        # dont piss of the user!

    return @returnList,
};

exit main;





sub get_layer_name
{
    my $tempTile=shift;
    my $layerNum=shift;
    my @tempTileLayers=$tempTile->get_layers();    
    my $layerName= $tempTileLayers[$layerNum]->get_name;;
    return ($layerName);
}















